package com.tmax.openframe.variable.group;

import ch.obermuhlner.math.big.BigDecimalMath;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public @AllArgsConstructor @NoArgsConstructor @Builder(builderClassName = "builder") class OIVPDELT_PEOPLE_INFO {
    public @Getter @Setter int WSKEY;
    public @Getter @Builder.Default String WS_NAME = StringUtils
            .repeat(' ', 10);
    public @Getter @Builder.Default String WS_DEPARTMENT = StringUtils.repeat(
            ' ', 15);
    public @Getter @Builder.Default String WS_PHONE = StringUtils.repeat(' ',
            15);
    public @Getter @Builder.Default String WS_EMAIL = StringUtils.repeat(' ',
            20);
    public @Getter @Builder.Default String WS_ADDRESS = StringUtils.repeat(' ',
            40);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public String getStringWSKEY() {
        return intFormatWithSign.apply((long) WSKEY, "00000000");
    }

    public void setWS_NAME(String source) {
        WS_NAME = StringUtils.truncate(StringUtils.rightPad(source, 10), 10);
    }

    public void setWS_DEPARTMENT(String source) {
        WS_DEPARTMENT = StringUtils.truncate(StringUtils.rightPad(source, 15),
                15);
    }

    public void setWS_PHONE(String source) {
        WS_PHONE = StringUtils.truncate(StringUtils.rightPad(source, 15), 15);
    }

    public void setWS_EMAIL(String source) {
        WS_EMAIL = StringUtils.truncate(StringUtils.rightPad(source, 20), 20);
    }

    public void setWS_ADDRESS(String source) {
        WS_ADDRESS = StringUtils.truncate(StringUtils.rightPad(source, 40), 40);
    }

    @Override
    public String toString() {
        return String.valueOf(getWSKEY()) + getWS_NAME() + getWS_DEPARTMENT()
                + getWS_PHONE() + getWS_EMAIL() + getWS_ADDRESS();
    }
}
